/*
//	Apple Event Core Dispatch routines
//	this code installs and responds to the basic apple event messages.
//
//	 1/29/93		By Brigham Stevens
//	 1992, 1993 Apple Computer, Inc.
//
*/
#include "GlobalDefs.h"
#include "AppleEvents.h"

pascal OSErr AEOpenApp( AppleEvent theAE, AppleEvent reply, long rfCon)
{
	NewDocument();
	return noErr;
}

pascal OSErr AEOpenDoc( AppleEvent  *theAE, AppleEvent  *reply, long  rfCon)
{
	/*
		Here we dig the FSSpec records out of the event.
	*/
	return errAEEventNotHandled;
}


pascal OSErr AEPrintDoc( AppleEvent  *theAE, AppleEvent  *reply, long  rfCon)
{
	return errAEEventNotHandled;
}


pascal OSErr AEQuitApp( AppleEvent  *theAE, AppleEvent  *reply, long  rfCon)
{
	gDone = true;		/* set flag to indicate that program should quit */	
	return noErr;
}

void DoHighLevelEvent(EventRecord *evt)
{
	OSErr	err;
	err = AEProcessAppleEvent(evt);
	if(err) {
		ErrMsgCode("\pError processing Apple Event",err);
	}	
}

void InstallAppleEventHandlers()
/*
	This function installs the AppleEvent handlers for the AppleEvents this program understands.
	Right now it installs a handler for all the core events.
*/
{
	OSErr	err;

	
	err = AEInstallEventHandler (kCoreEventClass, kAEOpenApplication, AEOpenApp,0,FALSE);
	if(err) {
		ErrMsgCode("\pCould not install AE handler.",err);
		ExitToShell();
	}
	
	err = AEInstallEventHandler (kCoreEventClass, kAEOpenDocuments, AEOpenDoc,0,FALSE);
	if(err) {
		ErrMsgCode("\pCould not install AE handler.",err);
		ExitToShell();
	}
		
	err = AEInstallEventHandler (kCoreEventClass, kAEPrintDocuments, AEPrintDoc,0,FALSE);
	if(err) {
		ErrMsgCode("\pCould not install AE handler.",err);
		ExitToShell();
	}

	err = AEInstallEventHandler (kCoreEventClass, kAEQuitApplication, AEQuitApp,0,FALSE);
	if(err) {
		ErrMsgCode("\pCould not install AE handler.",err);
		ExitToShell();
	}
	
}