/*
	9-30-92   Brigham Stevens
	--------------------------

	This file contains the standard witch chant for getting the Mac going
*/

#include "GlobalDefs.h"
#include "GestaltEQU.h"

void SystemCheck(void)
/*
	This routine checks the minimum requirements to execute.
	If it does not return, then the machine does not cut
	the mustard.
*/
{
	long	gestResult;
	OSErr	err;
	
	(void) Gestalt(gestaltSystemVersion,&gestResult);
	
	if (gestResult < 0x0700)	{
		ErrMsg("\pRequires System 7 or later!");
		ExitToShell();
	}

	err = Gestalt(gestaltAppleEventsAttr, &gestResult);
	if( (err != noErr) || !(gestResult & (1<<gestaltAppleEventsPresent)) ) {
		ErrMsg("\pRequires AppleEvents!");
		ExitToShell();
    }
	
	/* initialize the color quickdraw flag */	
	(void) Gestalt(gestaltQuickdrawVersion,&gestResult);
	if(gestResult >= gestalt8BitQD) gColorQD = true;
}

void InitToolBox(short numberOfMasters)
/*
	pass the number of times you want MoreMasters to be called
	if your app has lots of Handles to allocate
	then call MoreMasters lots of times.
*/
{
	
	while(numberOfMasters--)
		MoreMasters();

	InitGraf(&thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	InitCursor();
	TEInit();
	FlushEvents(everyEvent, 0);
	InitDialogs(nil);
	
	SystemCheck();

}
