/*
	9-30-92   Brigham Stevens
	--------------------------

	Bare minimum printing loop.
	Hacked out of Tech Note #161
	Calls UpdateDocument inside Document.c to image the page
*/

#include "GlobalDefs.h"
#include "Printing.h"

Boolean gPrinting = false;

pascal void PrintIdleProc(void)
{
	short	err;
	
	err = PrError();

	/*	we could spin the cursor here if we want */
		
	if(err) {
		InitCursor();		/* set to arrow */
		ErrMsgCode("\pI'm in the printing idle proc.",err);
	}
}

void PrintWindow(void)
/*
	This will call the drawing code set up in
	Document.c for the printing GrafPort
	when there is an error, the code gotoos the
	exit so the printer driver will be closed.
*/
{
	THPrint		tpr = nil;
	TPPrPort	printPort = nil;
	short		err = noErr;
	TPrStatus	tprStat;
	Boolean		needToCloseDriver = false;
	
	tpr = NewHandle(sizeof(TPrint));
	if(!tpr) {
		err = MemError();
		ErrMsgCode("\pAllocating TPrint failed.",err);
	}
	
	if(err == noErr) {
		PrOpen();
		if(err = PrError())
			ErrMsgCode("\p PrOpen failed.",err);
	}
	
	if(err == noErr) {
		needToCloseDriver = true;
		if(!PrStlDialog(tpr))
			err = paramErr;			// user selected cancel
		else if(err = PrError())
			ErrMsgCode("\p PrStlDialog failed.",err);
	
	}
	
	if(err == noErr) {
		if(!PrJobDialog(tpr))
			err = paramErr;			// user selected cancel
		else if(err = PrError())
			ErrMsgCode("\p PrJobDialog failed.",err);
	}
	

	if(err == noErr) {	
		SetCursor(*GetCursor(watchCursor));
		(**tpr).prJob.pIdleProc = PrintIdleProc;
		
		printPort = PrOpenDoc(tpr, nil, nil);
		if(err = PrError())
			ErrMsgCode("\p PrOpenDoc failed.",err);
	}
	
	if(err == noErr) {
		PrOpenPage(printPort, nil);
		if(err = PrError())
			ErrMsgCode("\p PrOpenPage failed.",err);
	}
	
	if(err == noErr) {
		gPrinting = true;
		UpdateDocument(printPort);
		gPrinting = false;
		
		PrClosePage(printPort);
		if(err = PrError())
			ErrMsgCode("\p PrClosePage failed.",err);
	}
	
	if(err == noErr) {
		PrCloseDoc(printPort);
		if(err = PrError())
			ErrMsgCode("\p PrCloseDoc failed.",err);
	}
	
	if(err == noErr) {
		if( ((**tpr).prJob.bJDocLoop == bSpoolLoop))
			PrPicFile( tpr, nil, nil, nil, &tprStat);
		if(err = PrError())
			ErrMsgCode("\p PrPicFile failed.",err);
	}
	
	if(needToCloseDriver == true) {
		PrClose();
		if(err = PrError())
			ErrMsgCode("\p PrClose failed.",err);
	}

	/* restore the cursor to regular arrow */
	InitCursor();
}